# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2017_09_01_preview
  module Models
    #
    # Properties of the file.
    #
    class File

      include MsRestAzure

      # @return [String] file name
      attr_accessor :name

      # @return [String] file download url, example:
      # https://mystg.blob.core.windows.net/mycontainer/myModel_1.dnn. This
      # will be returned only if the model has been archived. During job run,
      # this won't be returned and customers can use SSH tunneling to download.
      # Users can use Get Remote Login Information API to get the IP address
      # and port information of all the compute nodes running the job.
      attr_accessor :download_url

      # @return [DateTime] The time at which the file was last modified. The
      # time at which the file was last modified.
      attr_accessor :last_modified

      # @return [Integer] The file size. The file size.
      attr_accessor :content_length


      #
      # Mapper for File class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'File',
          type: {
            name: 'Composite',
            class_name: 'File',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              download_url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'downloadUrl',
                type: {
                  name: 'String'
                }
              },
              last_modified: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastModified',
                type: {
                  name: 'DateTime'
                }
              },
              content_length: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.contentLength',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
