# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # CNTK (aka Microsoft Cognitive Toolkit) job settings.
    #
    class CNTKsettings

      include MsRestAzure

      # @return [String] Language type. The language to use for launching CNTK
      # (aka Microsoft Cognitive Toolkit) job. Valid values are 'BrainScript'
      # or 'Python'.
      attr_accessor :language_type

      # @return [String] Config file path. Specifies the path of the
      # BrainScript config file. This property can be specified only if the
      # languageType is 'BrainScript'.
      attr_accessor :config_file_path

      # @return [String] Python script file path. Python script to execute.
      # This property can be specified only if the languageType is 'Python'.
      attr_accessor :python_script_file_path

      # @return [String] Python interpreter path. The path to the Python
      # interpreter. This property can be specified only if the languageType is
      # 'Python'.
      attr_accessor :python_interpreter_path

      # @return [String] Command line arguments. Command line arguments that
      # need to be passed to the python script or cntk executable.
      attr_accessor :command_line_args

      # @return [Integer] Process count. Number of processes to launch for the
      # job execution. The default value for this property is equal to
      # nodeCount property
      attr_accessor :process_count


      #
      # Mapper for CNTKsettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CNTKsettings',
          type: {
            name: 'Composite',
            class_name: 'CNTKsettings',
            model_properties: {
              language_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'languageType',
                type: {
                  name: 'String'
                }
              },
              config_file_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'configFilePath',
                type: {
                  name: 'String'
                }
              },
              python_script_file_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pythonScriptFilePath',
                type: {
                  name: 'String'
                }
              },
              python_interpreter_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pythonInterpreterPath',
                type: {
                  name: 'String'
                }
              },
              command_line_args: {
                client_side_validation: true,
                required: false,
                serialized_name: 'commandLineArgs',
                type: {
                  name: 'String'
                }
              },
              process_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'processCount',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
